% billateral key exchange with public key protocol
% (approx. 9s to verify)

responder(A,B,Na,Nb,Kab,[ 
   resp(A,B,Na,Nb,Kab),
   [
   recv([B, [Nb, B]*pk(A)]),
   send([sha(Nb), [Na, [A, Kab]]]*pk(B)),   
   recv(sha(Na)+Kab)
   ]
 ]).

initiator(A,B,Na,Nb,Kab,[ 
   resp(A,B,Na,Nb,Kab),
   [
   send([B, [Nb, B]*pk(A)]),
   recv([sha(Nb), [Na, [A, Kab]]]*pk(B)),   
   send(sha(Na)+Kab)
   ]
 ]).

secrecy(N,[secr(N),[recv(N)]]).

semibundle([St,Sa1,Sb1,Sa2,Sb2,Sa3,Sb3],[[_,[]],_,_,_,_,_,_],[a,b,e]) 
:-
   initiator(a,b,na1,nb1,kab1,Sa1),
   responder(a,b,na1,nb1 ,kab1,Sb1),

   initiator(a,b,na2,nb2,kab2,Sa2),
   responder(a,b,na2,nb2 ,kab2,Sb2),

   initiator(a,b,na3,nb3,kab3,Sa3),
   responder(a,b,na3,nb3 ,kab3,Sb3),

   secrecy(nb1, St).

